""" Subtypes interfaces
"""
from zope import schema
from zope.interface import Interface


class IUberlistingWrapper(Interface):
    """ Wrapper for faceted navigable objects
    """

class IUberlistingSubtyper(Interface):
    """ Support for subtyping objects
    """

    can_enable = schema.Bool(u'Can enable faceted navigation',
                             readonly=True)
    can_disable = schema.Bool(u'Can disable faceted navigation',
                              readonly=True)
    is_uberlisting = schema.Bool(u'Is current object faceted navigable',
                             readonly=True)

    def enable():
        """ Enable faceted navigation
        """

    def disable():
        """Disable faceted navigation
        """
