""" Uberlisting View events
"""
from zope.interface import implements
from zope.component.interfaces import ObjectEvent
from eea.uberlisting.interfaces import (
    IUberlistingEvent,
    IUberlistingWillBeEnabledEvent,
    IUberlistingEnabledEvent,
    IUberlistingWillBeDisabledEvent,
    IUberlistingDisabledEvent,
)

class UberlistingEvent(ObjectEvent):
    """ Abstract uberlisting event. All uberlisting events should inherit from it """
    implements(IUberlistingEvent)


class UberlistingWillBeEnabledEvent(UberlistingEvent):
    """ Event triggered if uberlistings view is going to be enabled """
    implements(IUberlistingWillBeEnabledEvent)

class UberlistingEnabledEvent(UberlistingEvent):
    """ Event triggered if uberlistings view was enabled """
    implements(IUberlistingEnabledEvent)

class UberlistingWillBeDisabledEvent(UberlistingEvent):
    """ Event triggered if uberlistings view is going to be disabled """
    implements(IUberlistingWillBeDisabledEvent)

class UberlistingDisabledEvent(UberlistingEvent):
    """ Event triggered if uberlistings view was disabled """
    implements(IUberlistingDisabledEvent)
