from zope import schema
from zope.interface import Interface


class IUberlistingNavigable(Interface):
    """ Marker interface for faceted navigable objects
    """

class IPossibleUberlistingNavigable(Interface):
    """ Marker interface for faceted navigable objects
    """

class IUberlistingWrapper(Interface):
    """ Wrapper for faceted navigable objects
    """

class IUberlistingSubtyper(Interface):
    """ Support for subtyping objects
    """

    can_enable = schema.Bool(u'Can enable uberlistings view',
                             readonly=True)
    can_disable = schema.Bool(u'Can disable uberlistings view',
                              readonly=True)
    is_uberlisting = schema.Bool(u'Is current object uberlisting navigable',
                             readonly=True)

    def enable():
        """ Enable uberlisting view
        """

    def disable():
        """Disable uberlisting view
        """
