""" Wrapper
"""
from Acquisition import Implicit
from AccessControl import ClassSecurityInfo
from App.class_init import InitializeClass

from zope.traversing.interfaces import ITraversable
from zope.traversing.adapters import DefaultTraversable

from zope.interface import implements
from eea.uberlisting.subtypes.interfaces import IUberlistingWrapper


class UberlistingWrapper(Implicit):
    """ Wrap uberlisting container
    """
    implements(IUberlistingWrapper, ITraversable)

    security = ClassSecurityInfo()

    def __init__(self, context):
        self.context = context

    def __call__(self, content=None):
        self.content = content
        return self.__of__(self.context)

    def traverse(self, name, furtherPath):
        """ Make this wrapper traversable
        """
        return DefaultTraversable(self.context).traverse(name, furtherPath)

InitializeClass(UberlistingWrapper)
